var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
define(["require", "exports", "esri/core/accessorSupport/decorators", "esri/widgets/support/widget", "esri/widgets/Widget"], function (require, exports, decorators_1, widget_1, Widget) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var ZoomToUnique = /** @class */ (function (_super) {
        __extends(ZoomToUnique, _super);
        function ZoomToUnique(layerView, field, params) {
            var _this = _super.call(this, params) || this;
            _this._currentChoice = "";
            _this.choices = [];
            _this.comboBox = null;
            _this.layerView = layerView;
            _this.field = field;
            return _this;
        }
        ZoomToUnique.prototype.getLayerChoices = function () {
            var _this = this;
            var layer = this.layerView.layer;
            var queryParams = layer.createQuery();
            queryParams.returnDistinctValues = true;
            queryParams.returnGeometry = false;
            queryParams.where = "1=1";
            queryParams.outFields = [this.field];
            layer.queryFeatures(queryParams).then(function (features) {
                _this.comboBox = document.createElement("select");
                features.features.forEach(function (g) {
                    var choice = g.attributes[_this.field];
                    _this.choices.push(choice);
                    var option = document.createElement("option");
                    option.value = choice;
                    option.text = choice;
                    _this.comboBox.add(option);
                });
                if (_this._currentChoice === "")
                    _this._currentChoice = _this.choices[0];
                _this.renderNow();
            });
        };
        ZoomToUnique.prototype.zoomToChoice = function () {
            if (this.comboBox == null)
                return;
            console.warn("Not implemented!");
        };
        ZoomToUnique.prototype.render = function () {
            return (widget_1.tsx("div", { class: "esri-widget" },
                widget_1.tsx("h3", null, this.field),
                widget_1.tsx("br", null),
                widget_1.tsx("select", null, this.choices.map(function (c) { return widget_1.tsx("option", { value: c }, c); }))));
        };
        __decorate([
            decorators_1.property()
        ], ZoomToUnique.prototype, "choices", void 0);
        __decorate([
            decorators_1.property()
        ], ZoomToUnique.prototype, "comboBox", void 0);
        __decorate([
            decorators_1.property()
        ], ZoomToUnique.prototype, "layerView", void 0);
        __decorate([
            decorators_1.property()
        ], ZoomToUnique.prototype, "field", void 0);
        ZoomToUnique = __decorate([
            decorators_1.subclass("esri.widgets.ZoomToUnique")
        ], ZoomToUnique);
        return ZoomToUnique;
    }(decorators_1.declared(Widget)));
    exports.default = ZoomToUnique;
});
//# sourceMappingURL=ZoomToUnique.js.map